<?php

/**
 * @file
 * Cache handling specific functions.
 */

function devcontrol_cache_clear_hook() {
  cache_clear_all('module_implements', 'cache_bootstrap');
  cache_clear_all('hook_info', 'cache_bootstrap');
  cache_clear_all('boostrap_modules', 'cache_bootstrap');
  drupal_theme_rebuild();
  drupal_static_reset('module_implements');

  return t("Cached hook information and theme registry have been destroyed");
}

function devcontrol_cache_clear_locale() {
  cache_clear_all('locale', 'cache', true);
  drupal_static_reset('locale');

  return t("Locale cache has been destroyed");
}

function devcontrol_cache_clear_form() {
  cache_clear_all('*', 'cache_form', true);

  return t("Form cache and state have been dropped");
}

function devcontrol_cache_clear_simpletest() {
  simpletest_clean_environment();

  return t("Simpletest environment has been cleaned up");
}

function devcontrol_cache_clear_theme() {
  drupal_theme_rebuild();

  return t("Theme registry cache has been destroyed");
}

function devcontrol_cache_clear_views() {
  cache_clear_all('*', 'cache_views', true);
  cache_clear_all('*', 'cache_views_data', true);

  return t("Views cache has been destroyed");
}

function devcontrol_cache_clear_menu() {
  menu_rebuild();

  return t("Menu has been rebuilt");
}

function devcontrol_cache_clear_registry() {
  registry_rebuild();

  return t("Registry has been rebuilt");
}

function devcontrol_cache_clear_field() {
  field_cache_clear();

  return t("Field cache has been cleared");
}

function devcontrol_cache_clear_entityinfo() {
  entity_info_cache_clear();

  return t("Entity info has been cleared");
}

function devcontrol_cache_clear_entitycache() {
  foreach (entitycache_flush_caches() as $bin) {
    cache_clear_all('*', $bin, true);
  }

  return t("Entity cache has been cleared");
}

function devcontrol_cache_clear_all() {
  drupal_flush_all_caches();

  return t('Caches cleared.');
}